



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>lightoj 1282 &amp;&amp; uva 11029</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">lightoj 1282 &amp;&amp; uva 11029</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 19:47:25 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>Leading and Trailing</strong></p>
<p>lightoj 链接：<a href="http://lightoj.com/volume_showproblem.php?problem=1282" rel="external nofollow noreferrer">http://lightoj.com/volume_showproblem.php?problem=1282</a></p>
<p>uva 链接：<a href="http://uva.onlinejudge.org/index.php?option=com_onlinejudge&amp;Itemid=8&amp;page=show_problem&amp;problem=1970" rel="external nofollow noreferrer">http://uva.onlinejudge.org/index.php?option=com_onlinejudge&amp;Itemid=8&amp;page=show_problem&amp;problem=1970</a></p>
<p><strong>题意</strong>：给定 n， k ，求 n<sup>k</sup> 的前3位和后三位的值。</p>
<p><strong>思路</strong>：<strong>1</strong>、前 3 位：把 n<sup>k</sup> 转化为 a.bc * 10<sup>m&nbsp;</sup>，两边取 10 的对数得到 k * lg(n) = m + lg(a.bc) &nbsp;( lg(a.bc) &lt; 1 ) 。 所以把 k * lg(n) 减掉整数部分(即 m )就可以得到</p>
<p>lg(a.bc) ， 然后计算 10 <sup>lg(a.bc) </sup> * 100 就能得到答案。</p>
<p>　　<strong>2</strong>、后3位：把 k 化成二进制的数，进行快速幂取模运算，没难度。</p>
<p><strong>代码</strong>：</p>
<p>lightoj 1282&nbsp;代码：</p>
<div>
<pre class="prettyprint linenums"> #include &lt;iostream&gt;<br />
 #include &lt;stdio.h&gt;<br />
 #include &lt;math.h&gt;<br />
 using namespace std;

 typedef long long LL;<br />
 int n, k;

 int front(int n, int k)    //前3位<br />
 {<br />
     double s = k*log10(n) - (int) (k*log10(n));    //取对数<br />
     s = pow(, s);<br />
     return s * ;<br />
 }

 int rear(int n, int k) //后3位<br />
 {<br />
     if(!k)    return ;    //快速幂<br />
     LL s = rear(n, k/);<br />
     if(k&amp;)    s = s*s %  * n % ;<br />
     else    s = s*s % ;<br />
     return s % ;<br />
 }

 int main()<br />
 {<br />
     int t, i;<br />
     cin &gt;&gt; t;<br />
     for(i = ; i &lt;= t; ++i)<br />
     {<br />
         scanf("%d%d", &amp;n, &amp;k);<br />
         printf("Case %d: %d %03d\n", i, front(n, k), rear(n, k));<br />
     }<br />
     return ;<br />
 }</pre>
</div>
<p>uva 11029 代码：</p>
<div>
<pre class="prettyprint linenums"> #include &lt;iostream&gt;<br />
 #include &lt;stdio.h&gt;<br />
 #include &lt;math.h&gt;<br />
 using namespace std;

 typedef long long LL;<br />
 int n, k;

 int front(int n, int k)    //前3位<br />
 {<br />
     double s = k*log10(n) - (int) (k*log10(n));    //取对数<br />
     s = pow(, s);<br />
     return s * ;<br />
 }

 int rear(int n, int k) //后3位<br />
 {<br />
     if(!k)    return ;    //快速幂<br />
     LL s = rear(n, k/);<br />
     if(k&amp;)    s = s*s %  * n % ;<br />
     else    s = s*s % ;<br />
     return s % ;<br />
 }

 int main()<br />
 {<br />
     int t;<br />
     cin &gt;&gt; t;<br />
     while(t--)<br />
     {<br />
         scanf("%d%d", &amp;n, &amp;k);<br />
         printf("%d...%03d\n", front(n, k), rear(n, k));<br />
     }<br />
     return ;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8m267oq.html">PHP&plus;ajaxfileupload与jcrop插件结合 完成头像上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx6e6dq.html">站点图标favicon&period;ico</a>
		</li>
						<li><a href="https://www.batexi.com/a/m962zz3q.html">【转】html、css、js文件加载顺序及执行情况</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qynn4g9.html">【转】win8&period;1下安装ubuntu</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxplxv9.html">Tasks&period;Parallel</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x3ndv8.html">PHP引用文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnyk36q.html">Swift数字类型之间的转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1devj9.html">几个css的小知识点（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeyz0j9.html">Java---IO加强&lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmojjl9.html">CUGBACM&lowbar;Summer&lowbar;Tranning 组队赛解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkeg3v8.html">解决修改mysql的data&lowbar;dir所引发的错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkjgr08.html">HTML-----&amp;lt&semi;a&amp;gt&semi;、&amp;lt&semi;table&amp;gt&semi;、&amp;lt&semi;form&amp;gt&semi;解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj0k209.html">Linux下查看alert日志文件的两种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjxv4x8.html">session&period;go</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge72448.html">博主新建Linux学习交流群，欢迎广大大神入驻~</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ww10gq.html">Java 容器源码分析之 Set</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdyxxv9.html">Asianux 7&period;3安装Oracle 11&period;2&period;0&period;4单实例体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jwkl0q.html">for&period;&period;&period;else 小记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1wzwpq.html">python3笔记（一）初识Python</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjyye69.html">偷懒把本来要判断输入值的textbox 输出提示值，结果点两次程序异常</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e001ejq.html">&lbrack;ML&rsqb; the notes</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2xxwww9.html">&lbrack;leetcode-670-Maximum Swap&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e0014xq.html">Appium基础环境搭建（windows）---基于python</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jee0rl8.html">mysql mariadb 密码设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kmm1w39.html">软件管理&mdash;&mdash;rpm&amp;amp&semi;dpkg、yum&amp;amp&semi;apt-get</a>
			</li>
						<li><a href="https://www.batexi.com/a/93jjykr8.html">20172333 2017-2018-2 《Java程序设计》第7周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jeez5g8.html">Android - 时间 日期相关组件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zvvym19.html">lintcode-148-颜色分类</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jeemmw8.html">iOS开发Interface Builder技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jeempw8.html">TCP系列29&mdash;窗口管理&amp;流控&mdash;3、Nagle算法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
